"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var subtle = require('node:crypto').webcrypto.subtle;
var compatibilityMatrix_1 = __importDefault(require("./compatibilityMatrix"));
function isFormatSupported(alg, format) {
    return compatibilityMatrix_1.default[format].includes(alg);
}
function exportKey(key, format) {
    return __awaiter(this, void 0, void 0, function () {
        var VALID_FORMATS;
        return __generator(this, function (_a) {
            VALID_FORMATS = ['spki', 'pkcs8', 'jwk', 'raw'];
            if (!VALID_FORMATS.includes(format)) {
                throw new Error('Invalid Format Argument');
            }
            if (!key.extractable) {
                throw new Error('Input Key is not extractable');
            }
            if (!isFormatSupported(key.algorithm.name, format)) {
                throw new Error("Target format does not support the key's algorithm");
            }
            // PKCS8 should only support private keys
            if (key.type != 'private' && format == 'pkcs8') {
                throw new Error("Cannot export public keys as PKCS8");
            }
            // SPKI should only support public keys
            if (key.type != 'public' && format == 'spki') {
                throw new Error("Cannot export private keys as SPKI");
            }
            // raw should only support public keys
            if (key.type == 'private' && format == 'raw') {
                throw new Error("Cannot export private keys as raw");
            }
            return [2 /*return*/, subtle.exportKey(format, key)];
        });
    });
}
exports.default = exportKey;
