"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var types_1 = require("util/types");
var generateSecret_1 = __importDefault(require("../src/generateSecret"));
var generateKeyPair_1 = __importDefault(require("../src/generateKeyPair"));
var exportKey_1 = __importDefault(require("../src/utils/exportKey"));
var compatibilityMatrix_1 = __importDefault(require("../src/utils/compatibilityMatrix"));
var algorithms_1 = require("../src/algorithms");
function exportSecretKeys(signatureAlgorithm, jwsHeader) {
    return __awaiter(this, void 0, void 0, function () {
        var _i, _a, alg, secret, _b, _c, _d, format, isSupportedByFormat, exported;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    _i = 0, _a = algorithms_1.SYNC_ALGS[signatureAlgorithm];
                    _e.label = 1;
                case 1:
                    if (!(_i < _a.length)) return [3 /*break*/, 7];
                    alg = _a[_i];
                    return [4 /*yield*/, (0, generateSecret_1.default)(alg)];
                case 2:
                    secret = _e.sent();
                    if (!(secret && (0, types_1.isCryptoKey)(secret))) return [3 /*break*/, 6];
                    _b = [];
                    for (_c in compatibilityMatrix_1.default)
                        _b.push(_c);
                    _d = 0;
                    _e.label = 3;
                case 3:
                    if (!(_d < _b.length)) return [3 /*break*/, 6];
                    format = _b[_d];
                    isSupportedByFormat = compatibilityMatrix_1.default[format].includes(jwsHeader);
                    if (!isSupportedByFormat) return [3 /*break*/, 5];
                    return [4 /*yield*/, (0, exportKey_1.default)(secret, format)];
                case 4:
                    exported = _e.sent();
                    expect(exported).not.toBeUndefined();
                    _e.label = 5;
                case 5:
                    _d++;
                    return [3 /*break*/, 3];
                case 6:
                    _i++;
                    return [3 /*break*/, 1];
                case 7: return [2 /*return*/];
            }
        });
    });
}
function exportPairedKeys(signatureAlgorithm) {
    return __awaiter(this, void 0, void 0, function () {
        var _i, _a, alg, secret, publicKey, privateKey, jwk_pub, jwk_pvt, spki_pub, pkcs8_pvt, raw_pub;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _i = 0, _a = algorithms_1.ASYNC_ALGS[signatureAlgorithm];
                    _b.label = 1;
                case 1:
                    if (!(_i < _a.length)) return [3 /*break*/, 10];
                    alg = _a[_i];
                    return [4 /*yield*/, (0, generateKeyPair_1.default)(alg)];
                case 2:
                    secret = _b.sent();
                    if (!secret) return [3 /*break*/, 9];
                    publicKey = secret.publicKey, privateKey = secret.privateKey;
                    return [4 /*yield*/, (0, exportKey_1.default)(publicKey, 'jwk')];
                case 3:
                    jwk_pub = _b.sent();
                    return [4 /*yield*/, (0, exportKey_1.default)(privateKey, 'jwk')];
                case 4:
                    jwk_pvt = _b.sent();
                    return [4 /*yield*/, (0, exportKey_1.default)(publicKey, 'spki')];
                case 5:
                    spki_pub = _b.sent();
                    return [4 /*yield*/, (0, exportKey_1.default)(privateKey, 'pkcs8')];
                case 6:
                    pkcs8_pvt = _b.sent();
                    if (!(signatureAlgorithm === 'ECDSA')) return [3 /*break*/, 8];
                    return [4 /*yield*/, (0, exportKey_1.default)(publicKey, 'raw')];
                case 7:
                    raw_pub = _b.sent();
                    expect(raw_pub).not.toBeUndefined();
                    _b.label = 8;
                case 8:
                    expect(jwk_pub).not.toBeUndefined();
                    expect(jwk_pvt).not.toBeUndefined();
                    expect(spki_pub).not.toBeUndefined();
                    expect(pkcs8_pvt).not.toBeUndefined();
                    _b.label = 9;
                case 9:
                    _i++;
                    return [3 /*break*/, 1];
                case 10: return [2 /*return*/];
            }
        });
    });
}
describe("Test exportKey()", function () {
    test("should be able to export keys under HMAC_SHA algorithms", function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, exportSecretKeys('HMAC_SHA', 'HMAC')];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    test("should be able to export keys under AES_KW algorithms", function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, exportSecretKeys('AES_KW', 'AES-KW')];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    test("should be able to export keys under AES_GCM algorithms", function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, exportSecretKeys('AES_GCM', 'AES-GCM')];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    test("should be able to export keys under RSA algorithms", function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, exportPairedKeys('RSA')];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    test("should be able to export keys under ECDSA algorithms", function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, exportPairedKeys('ECDSA')];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
});
