"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var types_1 = require("util/types");
var algorithms_1 = require("../src/algorithms");
var generateSecret_1 = __importDefault(require("../src/generateSecret"));
describe("Test generateSecret()", function () {
    test("should return a CryptoKey", function () { return __awaiter(void 0, void 0, void 0, function () {
        var secret;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, (0, generateSecret_1.default)('A128KW')];
                case 1:
                    secret = _a.sent();
                    expect((0, types_1.isCryptoKey)(secret)).toEqual(true);
                    return [2 /*return*/];
            }
        });
    }); });
    test("should return a KeyObject", function () { return __awaiter(void 0, void 0, void 0, function () {
        var secret;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, (0, generateSecret_1.default)('A128KW', { toKeyObject: true })];
                case 1:
                    secret = _a.sent();
                    expect((0, types_1.isKeyObject)(secret)).toEqual(true);
                    return [2 /*return*/];
            }
        });
    }); });
    test("should return an error if an invalid option property is passed as an argument", function () { return __awaiter(void 0, void 0, void 0, function () {
        var invalidProperty, error_1;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    invalidProperty = 'notValidProperty';
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, (0, generateSecret_1.default)('HS256', (_a = {}, _a[invalidProperty] = true, _a))];
                case 2:
                    _b.sent();
                    return [3 /*break*/, 4];
                case 3:
                    error_1 = _b.sent();
                    if (error_1 instanceof Error) {
                        expect(error_1.message).toBe("".concat(invalidProperty, " is not a valid option for generateSecret()"));
                    }
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    }); });
    test("should return an error if an invalid algorithm is placed as an argument", function () { return __awaiter(void 0, void 0, void 0, function () {
        var error_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, (0, generateSecret_1.default)('RS256')];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 3];
                case 2:
                    error_2 = _a.sent();
                    if (error_2 instanceof Error) {
                        expect(error_2.message).toBe('Invalid Symmetric Algorithm');
                    }
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    test("should work with every algorithm within HMAC_SHA (algorithms.ts)", function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            algorithms_1.SYNC_ALGS['HMAC_SHA'].forEach(function (alg) { return __awaiter(void 0, void 0, void 0, function () {
                var secret;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, (0, generateSecret_1.default)(alg)];
                        case 1:
                            secret = _a.sent();
                            expect((0, types_1.isCryptoKey)(secret)).toEqual(true);
                            return [2 /*return*/];
                    }
                });
            }); });
            return [2 /*return*/];
        });
    }); });
    test("should work with every algorithm within AES_KW (algorithms.ts)", function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            algorithms_1.SYNC_ALGS['AES_KW'].forEach(function (alg) { return __awaiter(void 0, void 0, void 0, function () {
                var secret;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, (0, generateSecret_1.default)(alg)];
                        case 1:
                            secret = _a.sent();
                            expect((0, types_1.isCryptoKey)(secret)).toEqual(true);
                            return [2 /*return*/];
                    }
                });
            }); });
            return [2 /*return*/];
        });
    }); });
    test("should work with every algorithm within AES_GCM (algorithms.ts)", function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            algorithms_1.SYNC_ALGS['AES_GCM'].forEach(function (alg) { return __awaiter(void 0, void 0, void 0, function () {
                var secret;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, (0, generateSecret_1.default)(alg)];
                        case 1:
                            secret = _a.sent();
                            expect((0, types_1.isCryptoKey)(secret)).toEqual(true);
                            return [2 /*return*/];
                    }
                });
            }); });
            return [2 /*return*/];
        });
    }); });
});
